/* API - Any Device - Any OS */
/* $Workfile: gsc_access.h $ */
/* $Revision: 4 $ */
/* $Date: 10/27/07 10:04a $ */
/* $Log: /NEW SOURCESAFE DATABASE/SDK/PLX/gsc/common/api/gsc_access.h $
 *
 * 4     10/27/07 10:04a Dnewbold
 * Ported to Linux.
 *
 * 3     5/09/06 1:31p Dnewbold
 * Increased code modularity.
 *
 * 2     5/04/06 3:33p Dnewbold
 * Removed key validation code and increased modularity.
 *
 * 1     8/22/05 11:51a Dnewbold
*/

#ifndef __GSC_ACCESS_H__
#define __GSC_ACCESS_H__

#include "gsc_os_device.h"



/* #defines	*****************************************************************/

#define	GSC_DEVICE_IS_OPEN(ptr)		((ptr)->handle)
#define	GSC_GET_HANDLE(ptr)			((ptr)->handle)
#define	UL							unsigned long



/* typedefs	*****************************************************************/

typedef struct _dev_data_t	dev_data_t;

typedef struct
{
	U8			dev_index;
	U8			lst_index;
	U32			count;
	void*		handle;
	os_device_t	device;
} gsc_device_t;



/* prototypes	*************************************************************/

U32		gsc_close(gsc_device_t* device);
void	gsc_compute_base_index(void);
U32		gsc_count_boards(U8* count);
U32		gsc_open(U8 dev_index, U8 lst_index, gsc_device_t* device, void** handle);

U32		gsc_handle_validate(void*			handle,
							U8				lst_size,
							U32				st_size,
							gsc_device_t*	device,
							U8*				lst_index);



/* variables	*************************************************************/

extern	U32	api_initialized;
extern	U32	api_status;
extern	U32	api_status_arg;



#endif
