/* API - Any Device - Any OS */
/* $Workfile: gsc_bar.h $ */
/* $Revision: 3 $ */
/* $Date: 3/01/07 5:20p $ */
/* $Log: /NEW SOURCESAFE DATABASE/SDK/PLX/gsc/common/api/gsc_bar.h $
 *
 * 3     3/01/07 5:20p Dnewbold
 * Linted.
 *
 * 2     5/04/06 3:34p Dnewbold
 * Removed key validation code and increased modularity.
 *
 * 1     8/22/05 11:47a Dnewbold
*/

#ifndef __GSC_BAR_H__
#define __GSC_BAR_H__

#include "gsc_access.h"		/*lint !e537 */



/* typedefs	*****************************************************************/

typedef struct
{
	gsc_device_t*	device;
	U8				index;		// The X in "BARX".
	U32				reg;		// The GSC definition of the PCI register.
	U32				address;	// physical address
	U32				size;		// In bytes.
	U32				io_space;	// In I/O space?
	void*			ptr;		// Pointer usable by library.
} gsc_bar_t;



/* prototypes	*************************************************************/

U32		gsc_bar_create(gsc_bar_t* bar, gsc_device_t* device, U32 index, U32 reg);
U32		gsc_bar_destroy(gsc_bar_t* bar);
U32		gsc_bar_init(gsc_bar_t* bar);
U32		gsc_bar_map(gsc_bar_t* bar);
U32		gsc_bar_reg_mod(const gsc_bar_t* bar, U32 reg, U32 value, U32 mask);
U32		gsc_bar_reg_read(const gsc_bar_t* bar, U32 reg, U32* value);
U32		gsc_bar_reg_write(const gsc_bar_t* bar, U32 reg, U32 value);
U32		gsc_bar_unmap(gsc_bar_t* bar);



#endif
