/* API - Any Device - Any OS */
/* $Workfile: gsc_irq.h $ */
/* $Revision: 4 $ */
/* $Date: 3/01/07 5:27p $ */
/* $Log: /NEW SOURCESAFE DATABASE/SDK/PLX/gsc/common/api/gsc_irq.h $
 *
 * 4     3/01/07 5:27p Dnewbold
 *
 * 3     5/09/06 1:31p Dnewbold
 * Increased code modularity.
 *
 * 2     5/04/06 3:43p Dnewbold
 * Removed key validation code and increased modularity.
 *
 * 1     8/22/05 11:49a Dnewbold
*/

#ifndef __GSC_IRQ_H__
#define __GSC_IRQ_H__

#include "gsc_event.h"		/*lint !e537 */



/* #defines	*****************************************************************/

// These are used as index values.
#define	GSC_PLX_INT_DMA_0		0
#define	GSC_PLX_INT_DMA_1		1
#define	GSC_PLX_INT_LOCAL		2

#define	GSC_PLX_INT_QTY_MAX		3

#define	GSC_LOCAL_INT_QTY_MAX	32	/* REWORK required if made larger than 32. */



/* typedefs	*****************************************************************/

typedef struct
{
	int	dma0;
	int	dma1;
	int	local;
} gsc_irq_src_t;

typedef struct
{
	// All fields are filled in by common code.
	gsc_device_t*	device;		// Passed to PLX API.
	gsc_irq_src_t	src;		// Set of IRQ's of interest.
	gsc_event_t*	pci;							// PCI IRQ processing.
	gsc_event_t*	plx[GSC_PLX_INT_QTY_MAX];		// PLX IRQ processing.
	gsc_event_t*	local[GSC_LOCAL_INT_QTY_MAX];	// Local IRQ processing.
} gsc_irq_t;



/* prototypes	*************************************************************/

U32		gsc_irq_create(gsc_irq_t* irq, gsc_device_t* device);
void	gsc_irq_destroy(gsc_irq_t* irq);
U32		gsc_irq_disable(gsc_irq_t* irq);
U32		gsc_irq_enable(gsc_irq_t* irq);
U32		gsc_irq_local_create(gsc_irq_t* irq, const char* name, U32 int_id, gsc_event_t** local);
U32		gsc_irq_local_wait(gsc_irq_t* irq, U32 mask, U32 timeout_ms);
U32		gsc_irq_plx_create(gsc_irq_t* irq, const char* name, U32 int_id, gsc_event_t** plx);



#endif
