/* API - Any Device - Any OS */
/* $Workfile: gsc_mem.h $ */
/* $Revision: 7 $ */
/* $Date: 10/27/07 3:23p $ */
/* $Log: /NEW SOURCESAFE DATABASE/SDK/PLX/gsc/common/api/gsc_mem.h $
 *
 * 7     10/27/07 3:23p Dnewbold
 * Remove some dead and commented out code.
 *
 * 6     10/27/07 10:12a Dnewbold
 * Ported to Linux.
 *
 * 5     4/02/07 4:52p Dnewbold
 * Ported to Linux.
 *
 * 4     3/01/07 5:28p Dnewbold
 * Linted.
 *
 * 3     5/09/06 1:31p Dnewbold
 * Increased code modularity.
 *
 * 2     5/04/06 3:44p Dnewbold
 * Removed key validation code and increased modularity.
 *
 * 1     8/22/05 11:49a Dnewbold
*/

#ifndef __GSC_MEM_H__
#define __GSC_MEM_H__

#include "gsc_access.h"		/*lint !e537 */
#include "gsc_sem.h"		/*lint !e537 */



/* typedefs	*****************************************************************/

typedef struct
{
	gsc_device_t*	device;
	gsc_sem_t		sem;
	U32				size;		// The size of the memory allocation.
	OS_USR_ADDR_T	usr_adrs;	// The user space address.
	unsigned long	phy_adrs;	// The physical address used for DMA.
} gsc_mem_t;



/* prototypes	*************************************************************/

U32		gsc_mem_alloc(gsc_mem_t* mem, U32 size, gsc_mem_t* dest);
U32		gsc_mem_create(gsc_mem_t* mem, const char* name, gsc_device_t* device);
void	gsc_mem_destroy(gsc_mem_t* mem);
U32		gsc_mem_free(gsc_mem_t* mem);
U32		gsc_mem_test(gsc_mem_t* mem, void* ptr, U32 size, gsc_mem_t* tmp);



#endif
