/* API - Any Device - Any OS */
/* $Workfile: gsc_version.h $ */
/* $Revision: 6 $ */
/* $Date: 4/04/07 9:42a $ */
/* $Log: /NEW SOURCESAFE DATABASE/SDK/PLX/gsc/common/api/gsc_version.h $
 *
 * 6     4/04/07 9:42a Dnewbold
 * A NULL device access handle is now always invalid.
 *
 * 5     3/01/07 5:04p Dnewbold
 * Linted and updated version comments.
 *
 * 4     10/12/06 12:46p Dnewbold
 * Added #include of gsc_os_version.h to correct overall version macro
 * expansion.
 *
 * 3     5/05/06 10:35a Dnewbold
 *
 * 2     5/04/06 3:48p Dnewbold
 * Removed key validation code and increased modularity.
 *
 * 1     8/22/05 11:51a Dnewbold
*/

#ifndef __GSC_VERSION_H__
#define __GSC_VERSION_H__

#include "gsc_access.h"		/*lint !e537 */
#include "gsc_common.h"		/*lint !e537 */

#include "gsc_os_version.h"



/* #define	*****************************************************************/

#define	API_GSC_VERSION				7
// 7	Removed key validation code and increased modularity. Linted code.
//		Made some changes for migration to 32-bit and 64-bit Linux.
//		Updated the handle validation code such that NULL is always invalid.
// 6	Ported to the SDK.
//
// 5	Fixed bug caused by requesting driver version data with a NULL handle.
//
// 4	Fixed bug caused by getting version data without the Driver Interface
//		Library.
//		Fixed a bug in the gsc_irq_local_wait() function.
//
// 3	Added gsc_dma_t* as an argument to gsc_io_create().
//
// 2	in gsc_common.h changed EXPORT to GSC_EXPORT and redefined to WINAPI.
//
// 1	initial release

#define	_STR(s)						# s
#define	__STR(s)					_STR(s)
#define	API_GSC_FILE_BASE_NAME		API_DEV_PRODUCT_NAME_LOWER "_api"
#define	ARRAY_ELEMENTS(a)			(sizeof((a))/sizeof((a)[0]))
#define	API_GSC_FILE_VERSION_STR	__STR(API_DEV_VERSION) "."		\
									__STR(API_DEV_OS_VERSION) "."	\
									__STR(API_GSC_VERSION) "."		\
									__STR(API_GSC_OS_VERSION) "."	\
									__STR(API_DEV_INTERFACE_VERSION)



/* prototypes	*************************************************************/

U32	gsc_version_get(gsc_device_t* device, U8 id, char* version, size_t size);
U32 gsc_version_verify(void);



#endif
