/* API - Any Device - Linux */
/* $Workfile: gsc_os_error.c $ */
/* $Revision: 1 $ */
/* $Date: 4/02/07 4:59p $ */
/* $Log: /NEW SOURCESAFE DATABASE/SDK/PLX/gsc/common/api/linux/gsc_os_error.c $
 *
 * 1     4/02/07 4:59p Dnewbold
*/

#include "gsc_os_error.h"

#include <errno.h>



/*****************************************************************************
*
*	Function:	os_errno_2_status
*
*	Purpose:
*
*		Convert an errno value to a status value.
*
*	Arguments:
*
*		error		The errno value to convert.
*
*	Returned:
*
*		GSC_SUCCESS	All went well.
*		else		An appropriate error code.
*
*****************************************************************************/

U32 os_errno_2_status(int error)
{
	U32	status;

	switch (error)
	{
		default:			status	= GSC_FAILED;					break;
		case 0:				status	= GSC_SUCCESS;					break;
		case EACCES:		status	= GSC_ACCESS_DENIED;			break;
		case EAGAIN:		status	= GSC_ACCESS_DENIED;			break;
		case EBADF:			status	= GSC_INVALID_HANDLE;			break;
		case EEXIST:		status	= GSC_INTERNAL_ERROR;			break;
		case EFAULT:		status	= GSC_INVALID_DATA;				break;
		case EINTR:			status	= GSC_FAILED;					break;
		case EINVAL:		status	= GSC_INVALID_DATA;				break;
		case EIO:			status	= GSC_FAILED;					break;
		case EISDIR:		status	= GSC_ACCESS_DENIED;			break;
		case ELOOP:			status	= GSC_ACCESS_DENIED;			break;
		case EMFILE:		status	= GSC_INSUFFICIENT_RESOURCES;	break;
		case ENAMETOOLONG:	status	= GSC_INTERNAL_ERROR;			break;
		case ENFILE:		status	= GSC_INSUFFICIENT_RESOURCES;	break;
		case ENODEV:		status	= GSC_ACCESS_DENIED;			break;
		case ENOENT:		status	= GSC_ACCESS_DENIED;			break;
		case ENOMEM:		status	= GSC_INSUFFICIENT_RESOURCES;	break;
		case ENOSPC:		status	= GSC_INSUFFICIENT_RESOURCES;	break;
		case ENOTDIR:		status	= GSC_ACCESS_DENIED;			break;
		case ENOTTY:		status	= GSC_INVALID_HANDLE;			break;
		case ENXIO:			status	= GSC_ACCESS_DENIED;			break;
		case EROFS:			status	= GSC_ACCESS_DENIED;			break;
		case ETXTBSY:		status	= GSC_ACCESS_DENIED;			break;
	}

	return(status);
}



