/* Any Device - API - Linux */
/* $Workfile: gsc_os_event.h $ */
/* $Revision: 2 $ */
/* $Date: 10/27/07 10:18a $ */
/* $Log: /NEW SOURCESAFE DATABASE/SDK/PLX/gsc/common/api/linux/gsc_os_event.h $
 *
 * 2     10/27/07 10:18a Dnewbold
 * API porting updates.
 *
 * 1     4/02/07 4:59p Dnewbold
*/

#ifndef __GSC_OS_EVENT_H__
#define __GSC_OS_EVENT_H__

typedef struct _os_event_t		os_event_t;
typedef struct _os_event_node_t	os_event_node_t;

#include <pthread.h>

#include "gsc_os_key.h"
#include "gsc_common.h"
#include "gsc_os_device.h"



/* typedefs	*****************************************************************/

struct _os_event_node_t
{
	pthread_cond_t				cond;	// The condition variable.
	int							count;
	int							trash;	// Set this to abort normal resume.
	const os_event_t**			list;
	struct _os_event_node_t*	prev;
	struct _os_event_node_t*	next;
};

struct _os_event_t
{
	os_key_t		key;	// First field!
	unsigned long	handle;
	char			name[64];
	os_device_t*	device;	// Used to block and resume threads.
};



/* prototypes	*************************************************************/

U32	os_event_create(os_event_t* event, const char* name, os_device_t* device);
U32	os_event_destroy(os_event_t* event);
U32	os_events_release(os_device_t* device);
U32	os_event_t_init(os_event_t* event);
U32	os_event_trigger(os_event_t* event);
U32	os_event_validate(os_event_t* event);
U32	os_event_wait(const os_event_t* event, U32 timeout_ms);
U32	os_event_wait_2(const os_event_t* e1, const os_event_t* e2, U32 timeout_ms);
U32	os_event_wait_multi(const os_event_t* list, U8 count, U32 timeout_ms);



#endif
