/* API - Any Device - Linux */
/* $Workfile: gsc_os_sem.h $ */
/* $Revision: 2 $ */
/* $Date: 10/27/07 10:19a $ */
/* $Log: /NEW SOURCESAFE DATABASE/SDK/PLX/gsc/common/api/linux/gsc_os_sem.h $
 *
 * 2     10/27/07 10:19a Dnewbold
 * API porting updates.
 *
 * 1     4/02/07 5:00p Dnewbold
*/

#ifndef __GSC_OS_SEM_H__
#define __GSC_OS_SEM_H__

#include <pthread.h>

#include "gsc_os_key.h"



/* typedefs	*****************************************************************/

typedef struct
{
	os_key_t		key;	// First field!
	pthread_mutex_t	mutex;
	char			name[64];
} os_sem_t;




/* prototypes	*************************************************************/

U32		os_sem_create(os_sem_t* sem, const char* name);
U32		os_sem_destroy(os_sem_t* sem);
U32		os_sem_lock(os_sem_t* sem);
void	os_sem_unlock(os_sem_t* sem);



#endif
