/* API - Any Device - Linux */
/* $Workfile: gsc_os_sleep.c $ */
/* $Revision: 2 $ */
/* $Date: 10/27/07 10:20a $ */
/* $Log: /NEW SOURCESAFE DATABASE/SDK/PLX/gsc/common/api/linux/gsc_os_sleep.c $
 *
 * 2     10/27/07 10:20a Dnewbold
 * API porting updates.
 *
 * 1     4/02/07 5:00p Dnewbold
*/

#include "gsc_os_sleep.h"
#include "gsc_common.h"

#include <pthread.h>
#include <unistd.h>
#include <sys/time.h>



/*****************************************************************************
*
*	Function:	os_sleep_ms
*
*	Purpose:
*
*		Sleep for the given number of milliseconds. The OS may sleep longer
*		than requested, much longer, due to factors outside our control.
*
*	Arguments:
*
*		ms	The number of milleseconds to sleep. If zero or less is given we
*			use one.
*
*	Returned:
*
*		None.
*
*****************************************************************************/

void os_sleep_ms(long ms)
{

	struct timeval	now;
	long			slept;
	struct timeval	start;
	long			want;

	gettimeofday(&start, NULL);

	if (ms < 1)
		ms	= 1;

	for (;;)
	{
		if (ms >= 1000)
		{
			want	= ms / 1000;
			sleep(want);
		}
		else if (ms >= 1)
		{
			want	= ms * 1000;
			usleep(want);
		}
		else
		{
			ms	= 1;
			usleep(1000);
		}

		gettimeofday(&now, NULL);
		slept	= (((long) now.tv_sec  - (long) start.tv_sec ) * 1000)
				+ (((long) now.tv_usec - (long) start.tv_usec) / 1000);

		if (slept >= ms)
			break;
	}
}


