/* API - Any Device - Linux */
/* $Workfile: gsc_os_thread.h $ */
/* $Revision: 1 $ */
/* $Date: 4/02/07 5:00p $ */
/* $Log: /NEW SOURCESAFE DATABASE/SDK/PLX/gsc/common/api/linux/gsc_os_thread.h $
 *
 * 1     4/02/07 5:00p Dnewbold
*/

#ifndef __GSC_OS_THREAD_H__
#define __GSC_OS_THREAD_H__

#include <pthread.h>

#include "gsc_os_key.h"
#include "gsc_common.h"



/* typedefs	*****************************************************************/

typedef struct
{
	os_key_t	key;		// First field!
	pthread_t	thread;
	char		name[64];
} os_thread_t;




/* prototypes	*************************************************************/

U32		os_thread_destroy(os_thread_t* thread);
U32		os_thread_wait(const os_thread_t* thread, U32 timeout_ms);

U32		os_thread_create(	os_thread_t*	thread,
							const char*		name,
							U32				(*function)(void* arg),
							void*			arg);



#endif
