/* API - Any Device - Linux */
/* $Workfile: gsc_os_time.c $ */
/* $Revision: 2 $ */
/* $Date: 10/27/07 10:20a $ */
/* $Log: /NEW SOURCESAFE DATABASE/SDK/PLX/gsc/common/api/linux/gsc_os_time.c $
 *
 * 2     10/27/07 10:20a Dnewbold
 * API porting updates.
 *
 * 1     4/02/07 5:00p Dnewbold
*/

#include "gsc_os_time.h"

#include <unistd.h>
#include <sys/time.h>



/*****************************************************************************
*
*	Function:	os_time_delta_ms
*
*	Purpose:
*
*		Return a relative change in time in milliseconds. The change in time
*		must be relative to a fixed point in time.
*
*	Arguments:
*
*		None.
*
*	Returned:
*
*		The change in time in milliseconds.
*
*****************************************************************************/

U32 os_time_delta_ms(void)
{
	static	int				started	= 0;
	static	struct timeval	start;

	U32						delta;
	U32						sec;
	struct timeval			tv;
	U32						us;

	if (started == 0)
	{
		gettimeofday(&start, NULL);
		started	= 1;
	}

	gettimeofday(&tv, NULL);
	sec		= tv.tv_sec - start.tv_sec;
	us		= 1000000L + tv.tv_usec - start.tv_usec;
	sec		+= us / 1000000L;
	us		= us % 1000000L;
	delta	= (sec * 1000) + (us / 1000);
	return(delta);
}


