/* This software is covered by the GNU GENERAL PUBLIC LICENSE (GPL). */
/* Any Device - Driver - Linux */
/* $Workfile: kernel_2_2.h $ */
/* $Revision: 3 $ */
/* $Date: 10/27/07 10:36a $ */
/*
*	Provide special handling for things specific to the 2.2 kernel.
*/
/* $Log: /NEW SOURCESAFE DATABASE/SDK/PLX/gsc/common/driver/linux/kernel_2_2.h $
 *
 * 3     10/27/07 10:36a Dnewbold
 * Additional driver porting updates.
 *
 * 2     3/29/07 2:47p Dnewbold
 *
 * 1     5/10/06 1:02p Dnewbold
*/

#ifndef __KERNEL_2_2_H__
#define __KERNEL_2_2_H__

#if	(LINUX_VERSION_CODE >= KERNEL_VERSION((2),2,0)) && \
	(LINUX_VERSION_CODE <  KERNEL_VERSION(2,3,0))

#include <asm/spinlock.h>
#include <linux/malloc.h>
#include <linux/wrapper.h>



/* #defines	**************************************************************/

#define	__GFP_NOWARN				0
#define	CURRENT_PROCESS_ID			current->pgrp
#define	DMA_SGL_SUPPORT_FIELD		/* SGL not supported in 2.2 drivers */
#define	EVENT_RESUME_IRQ(q,c)		wake_up_interruptible(q)
#define	EVENT_WAIT_IRQ_TO(q,c,t)	interruptible_sleep_on_timeout(q,t)
#define	GET_PAGE(page)				atomic_inc(&(page)->count)
#define	KILL_FASYNC(q,s,b)			kill_fasync((q),(s),(b))
#define	KMALLOC_LIMIT				(128L * 1024)
#define	PAGE_RESERVE(vpa)			mem_map_reserve(MAP_NR((vpa)))
#define	PAGE_UNRESERVE(vpa)			mem_map_unreserve(MAP_NR((vpa)))
#define	PCI_DEVICE_LOOP(p)			for (p=pci_devices;p;p=p->next)
#define	PCI_ENABLE_DEVICE(pci)		0
#define	REGION_IO_CHECK(a,s)		check_region(a,s)
#define	REGION_IO_RELEASE(a,s)		release_region(a,s)
#define	REGION_IO_REQUEST(a,s,n)	(void*) (request_region(a,s,n), 1)
#define	REGION_MEM_CHECK(a,s)		0
#define	REGION_MEM_RELEASE(a,s)
#define	REGION_MEM_REQUEST(a,s,n)	(void*) 1
#define	REMAP_PAGE_RANGE(v,f,t,s,p)	remap_page_range(f,t,s,p)
#define	SET_CURRENT_STATE(s)		current->state = (s); mb()
#define	SET_MODULE_OWNER(p)
#define	VADDR_T						unsigned long
#define	VIRT_TO_PAGE(p)				(mem_map + MAP_NR((p)))
#define	VM_OFFSET_BYTES(vma)		((vma)->vm_offset)
#define	VM_OPS_UNMAP(vmo,fun)		(vmo).unmap = (fun)
#define	VM_RESERVED					0
#define	WAIT_QUEUE_ENTRY_INIT(w,c)	(w)->task = (c)
#define	WAIT_QUEUE_ENTRY_T			struct wait_queue
#define	WAIT_QUEUE_HEAD_INIT(q)		init_waitqueue((q))
#define	WAIT_QUEUE_HEAD_T			struct wait_queue*

#define	IRQ_REQUEST(dv,fnc)			request_irq((dv)->pci->irq,				\
												(fnc),						\
												SA_SHIRQ,					\
												DRV_DEV_DEVICE_NAME_LOWER,	\
												(dv))



/* prototypes	**************************************************************/

void			irq_isr(int irq, void* dev_id, struct pt_regs* regs);

unsigned long	mmap_nopage(struct vm_area_struct*	vma,
							unsigned long			address,
							int						unused);

void		mmap_unmap(	struct vm_area_struct*	vma,
				unsigned long		addr,
				size_t			len);

int				proc_get_info(	char*	page,
								char**	start,
								off_t	offset,
								int		count,
								int		dummy);



#endif
#endif

