/* API - DMI32 - Any OS */
/* $Workfile: dev_io.h $ */
/* $Revision: 3 $ */
/* $Date: 10/27/07 10:44a $ */
/* $Log: /NEW SOURCESAFE DATABASE/SDK/PLX/gsc/dmi32/api/dev_io.h $
 *
 * 3     10/27/07 10:44a Dnewbold
 * Additional driver porting updates.
 *
 * 2     3/01/07 8:23a Dnewbold
 * Linted.
 *
 * 1     8/22/05 3:40p Dnewbold
*/

#ifndef __DEV_IO_H__
#define __DEV_IO_H__

#include "gsc_io.h"		/*lint !e537 */
#include "gsc_mem.h"

#include "dmi32_api.h"	/*lint !e537 */



/* typedefs	*****************************************************************/

struct _dev_io_t
{
	U32			offset;			// Starting I/O location.
	int			pio_active;		// Only one at a time due to BAR2 mapping.

	gsc_io_t	gio;			// For common I/O use.
	gsc_mem_t	mem;			// For DMA'able memory.
};



/* prototypes	*************************************************************/

// These are primarily for non-configuration parameters.

U32		io_dma_init(dev_data_t* dev);
U32		io_init(dev_data_t* dev, dev_io_t* dio);

// These are primarily for configuration parameters.

U32		io_abort(dev_data_t* dev, U32 which, UL set, UL* get);
U32		io_aborted(dev_data_t* dev, U32 which, UL set, UL* get);
U32		io_buffer_pointer(dev_data_t* dev, U32 which, UL set, UL* get);
U32		io_buffer_size(dev_data_t* dev, U32 which, UL set, UL* get);
U32		io_callback_arg(dev_data_t* dev, U32 which, UL set, UL* get);
U32		io_callback_func(dev_data_t* dev, U32 which, UL set, UL* get);
U32		io_dram_bank_select_force(gsc_io_t* gio);
U32		io_mode(dev_data_t* dev, U32 which, UL set, UL* get);
U32		io_offset(dev_data_t* dev, U32 which, UL set, UL* get);
U32		io_overlap_enable(dev_data_t* dev, U32 which, UL set, UL* get);
U32		io_status(dev_data_t* dev, U32 which, UL set, UL* get);
U32		io_timeout(dev_data_t* dev, U32 which, UL set, UL* get);



/* variables	*************************************************************/

extern	const gsc_io_func_t	io_dma_read_funcs;
extern	const gsc_io_func_t	io_dma_write_funcs;
extern	const gsc_io_func_t	io_pio_read_funcs;
extern	const gsc_io_func_t	io_pio_write_funcs;



#endif
