/* Application - DMI32 - Any OS */
/* $Workfile: dram.c $ */
/* $Revision: 2 $ */
/* $Date: 10/27/07 10:53a $ */
/* $Log: /NEW SOURCESAFE DATABASE/SDK/PLX/gsc/dmi32/bbtest/dram.c $
 *
 * 2     10/27/07 10:53a Dnewbold
 * Ported to Linux and updated API.
 *
 * 1     8/22/05 4:08p Dnewbold
*/

#include <stdio.h>

#include "main.h"
#include "util_label.h"



/*****************************************************************************
*
*	Function:	dram_info
*
*	Purpose:
*
*		Report information on the board's DRAM.
*
*	Arguments:
*
*		index	The index of the board being accessed.
*
*		handle	The handle used to access the device under test.
*
*		size	Report the size here.
*
*	Returned:
*
*		0		All went well.
*		> 0		The number of errors seen.
*
*****************************************************************************/

int dram_info(int index, void* handle, U32* size)
{
	unsigned long	capacity;
	int				errs	= 0;
	char			label[128];
	U32				status;
	unsigned long	ul;

	sprintf(label, "DRAM Information (%d)", index);
	label_text(label);
	printf("\n");
	label_level_inc();

	label_text("Capacity");
	status	= DMI32_MISC_DRAM_CAPACITY_MB__GET(handle, &capacity);

	if (status == GSC_SUCCESS)
	{
		printf("%ldMB\n", (long) capacity);
	}
	else
	{
		errs++;
		printf("FAIL <---\n");
	}

	label_text("Size");
	status	= DMI32_MISC_DRAM_SIZE_MB__GET(handle, &ul);
	size[0]	= (U32) ul;

	if (status == GSC_SUCCESS)
	{
		printf("%ldMB\n", (long) size[0]);
	}
	else
	{
		errs++;
		printf("FAIL <---\n");
	}

	label_level_dec();
	return(errs);
}


