/* Application - DMI32 - Any OS */
/* $Workfile: main.h $ */
/* $Revision: 3 $ */
/* $Date: 10/27/07 10:55a $ */
/* $Log: /NEW SOURCESAFE DATABASE/SDK/PLX/gsc/dmi32/bbtest/main.h $
 *
 * 3     10/27/07 10:55a Dnewbold
 * Updated comments for Linux porting effort.
 *
 * 2     10/16/06 9:56a Dnewbold
 * Updated the version number and comments.
 *
 * 1     8/22/05 4:08p Dnewbold
*/

#ifndef __MAIN_H__
#define __MAIN_H__

#include "dmi32_api.h"



/* #defines	*****************************************************************/

#define	VERSION				"1.05"
/* 1.05	Ported to Linux and updated API. Corrected help information. */
/* 1.04	Added host os identification. */
/* 1.03	Ported to the SDK. */
/* 1.02	*/
/* 1.01	*/
/* 1.00	Initial release. */

/*
*	On the DMI32 there is a hardware delay between when the "request" to begin
*	data transfer and when the data starts moving. The affect for transmission
*	is that the clock begins putting out data before the data appears at the
*	cable. At the end of the data stream the count runs down before full data
*	stream ends. A number of the first data vaues are not valid data and a
*	number at the end are not sent.  The affect for reception is similar. In
*	this test application this is referred to as SQEW.
*
*	During testing the maxium amount of "sqew" seen was 15 clock cycles for
*	the 2GB boards, though this would certainly very from one system to
*	another. For validation purposes I've permit upto 50 on the front and back
*	ends.
*
*	For the 4GB board the maximum amount of sqew seen was near 80 cycles. I've
*	bumped the sqew to 250 to compensate, for validation purposes.
*/


#define	SKEW				250

#define	_1K					(1024L)
#define	_1M					( _1K * _1K)
#define	_500K				(500L * _1K)
#define	_256M				(256L * _1M)
#define	_500M				(500L * _1M)



/* variables	**************************************************************/

extern	int		log_data;
extern	int		verbose;



/* prototypes	**************************************************************/

int	clock_test(int i0, void* h0, U32* c0, int i1, void* h1);
int	dram_info(int index, void* handle, U32* size);
int	irq_tests(int i0, void* h0, int i1, void* h1, int clock);
int	user_io_tests(int i0, void* h0, int i1, void* h1, int clock);
int	xfer_activity_config(void* h0, void* h1);
int	xfer_tests(int i0, void* h0, int i1, void* h1, int clock);



#endif
