#include <stdio.h>

#include "dmi32_api.h"
#include "dmi32_dsl.h"

U32	dmi32_dsl_clock_check(void* handle, U32* mhz, int verbose)
{
	U32				status;
	unsigned long	value;

	status	= DMI32_XFER_CLKIN_TEST__YES(handle, &value);
	mhz[0]	= (U32) value;

	if (!verbose)
	{
	}
	else if (status != GSC_SUCCESS)
	{
		mhz[0]	= 0;
		printf("Transfer CLKIN Test failure: %ld\n", (long) status);
	}
	else if (mhz[0] == DMI32_XFER_CLKIN_TEST_NONE)
	{
		mhz[0]	= 0;
		printf("No clock detected.\n");
	}
	else if (mhz[0] == DMI32_XFER_CLKIN_TEST_BUSY)
	{
		mhz[0]	= 0;
		printf("Clock test did not complete.\n");
	}
	else
	{
		printf("Clock Rate: %ldMHz\n", (long) mhz[0]);
	}

	return(status);
}
