#include <stdio.h>

#include "dmi32_api.h"
#include "dmi32_dsl.h"

U32	dmi32_dsl_multi_buffer_under_run_wait(
	void*	handle,
	U32		timeout_ms,
	int		verbose)
{
	U32	status;

	status	= dmi32_irq_wait(	handle,
								DMI32_WHICH_IRQ_MBUR,
								timeout_ms);

	if (!verbose)
	{
	}
	else if (status == GSC_SUCCESS)
	{
		printf("Under Run Wait: interrupt occurred.\n");
	}
	else if (status == GSC_WAIT_TIMEOUT)
	{
		printf(	"Under Run Wait: "
				"timeout after %ld milliseconds\n",
				(long) timeout_ms);
	}
	else
	{
		printf("dmi32_irq_wait() failure: %ld\n", (long) status);
	}

	return(status);
}
