#include <stdio.h>

#include "dmi32_api.h"
#include "dmi32_dsl.h"

U32 dmi32_dsl_tx_timeout_get(
	void*	handle,
	U32*	timeout_secs,
	int		verbose)
{
	U32				status;
	unsigned long	value;

	// Retrieve the Tx I/O timeout period without changing it.
	status	= dmi32_config(	handle,
							DMI32_IO_TIMEOUT,
							DMI32_WHICH_TX,
							GSC_NO_CHANGE,
							&value);
	timeout_secs[0]	= (U32) value;

	if (!verbose)
	{
	}
	else if (status != GSC_SUCCESS)
	{
		printf("dmi32_config() failure: %ld\n", (long) status);
	}
	else
	{
		printf(	"I/O Tx Timeout Set: %ld seconds\n",
				(long) timeout_secs);
	}

	return(status);
}
