#include <stdio.h>

#include "dmi32_api.h"
#include "dmi32_dsl.h"

U32	dmi32_dsl_tx_timeout_set(
	void*	handle,
	U32		timeout_s,
	int		verbose)
{
	unsigned long	get;
	U32				status;

	status	= dmi32_config(	handle,
							DMI32_IO_TIMEOUT,
							DMI32_WHICH_TX,
							timeout_s,
							&get);

	if (!verbose)
	{
	}
	else if (status != GSC_SUCCESS)
	{
		printf("dmi32_config() failure: 0x%lX\n", (long) status);
	}
	else
	{
		printf("Tx (write) Timeout:\n");
		printf("  Set: 0x%lX\n", (long) timeout_s);
		printf("  Get: 0x%lX\n", get);
	}

	return(status);
}
