#include <stdio.h>

#include "dmi32_api.h"
#include "dmi32_dsl.h"

U32	dmi32_dsl_tx_wait(void* handle, U32 timeout_ms, int verbose)
{
	U32	status;

	status	= dmi32_io_wait(handle, DMI32_WHICH_TX, timeout_ms);

	if (!verbose)
	{
	}
	else if (status == GSC_SUCCESS)
	{
		printf("Tx Wait: write operation completed.\n");
	}
	else if (status == GSC_WAIT_TIMEOUT)
	{
		printf(	"Tx Wait: timeout after %ld milliseconds\n",
				(long) timeout_ms);
	}
	else
	{
		printf("dmi32_io_wait() failure: %ld\n", (long) status);
	}

	return(status);
}
