/* Application - DMI32 - Any OS */
/* $Workfile: main.h $ */
/* $Revision: 3 $ */
/* $Date: 10/27/07 3:46p $ */
/* $Log: /NEW SOURCESAFE DATABASE/SDK/PLX/gsc/dmi32/sbtest/main.h $
 *
 * 3     10/27/07 3:46p Dnewbold
 * Updated version for Linux port.
 *
 * 2     10/16/06 9:56a Dnewbold
 * Updated the version number and comments.
 *
 * 1     8/22/05 4:10p Dnewbold
*/

#ifndef __MAIN_H__
#define __MAIN_H__

#include "dmi32_api.h"



/* #defines	*****************************************************************/

#define	VERSION				"1.03"
// 1.03	Ported to Linux.
// 1.02	Added host os identification.
// 1.01	Ported to the SDK.
//		Fixed a bug in the I/O Completion Notification test for NT.
//		Fixed a bug in the Strict DRAM Limit test code.
// 1.00	Initial release.

#define	ARRAY_ELEMENTS(a)	(sizeof((a))/sizeof((a)[0]))
#define	_1MB				(1L * 1024 * 1024)
#define	_2GB				(2UL * 1024 * 1024 * 1024)




/* prototypes	*************************************************************/

int	dram_access_rates(void* handle);
int	dram_access_test(void* handle, U32 size_mb);
int	dram_compute_size_mb(void* handle, U32* size_mb);
int	dram_memory_tests(void* handle, U32 size_mb);
int	io_config_tests(void* handle);
int	io_notify_tests(void* handle);
int	irq_config_tests(void* handle);
int	misc_config_tests(void* handle, U32* size_mb);
int	reg_read_test(void* handle);
int	reg_write_test(void* handle);
int	user_io_config_tests(void* handle);
int	xfer_config_tests(void* handle);



#endif
