/* Application - DMI32 - Any OS */
/* $Workfile: reg.c $ */
/* $Revision: 1 $ */
/* $Date: 8/22/05 4:10p $ */
/* $Log: /NEW SOURCESAFE DATABASE/SDK/PLX/gsc/dmi32/sbtest/reg.c $
 *
 * 1     8/22/05 4:10p Dnewbold
*/

#include <stdio.h>

#include "main.h"
#include "util_label.h"



/* variables	*************************************************************/

static const struct
{
	U32	reg;
	int	writeable;
} _reg_list[]	=
{
	/* reg						writeable	*/
	{ GSC_PCI_9080_VIDR,		0			},
	{ GSC_PCI_9080_DIDR,		0			},
	{ GSC_PCI_9080_CR,			0			},
	{ GSC_PCI_9080_SR,			0			},
	{ GSC_PCI_9080_REV,			0			},
	{ GSC_PCI_9080_CCR,			0			},
	{ GSC_PCI_9080_CLSR,		0			},
	{ GSC_PCI_9080_LTR,			0			},
	{ GSC_PCI_9080_HTR,			0			},
	{ GSC_PCI_9080_BISTR,		0			},
	{ GSC_PCI_9080_BAR0,		0			},
	{ GSC_PCI_9080_BAR1,		0			},
	{ GSC_PCI_9080_BAR2,		0			},
	{ GSC_PCI_9080_BAR3,		0			},
	{ GSC_PCI_9080_BAR4,		0			},
	{ GSC_PCI_9080_BAR5,		0			},
	{ GSC_PCI_9080_CIS,			0			},
	{ GSC_PCI_9080_SVID,		0			},
	{ GSC_PCI_9080_SID,			0			},
	{ GSC_PCI_9080_ERBAR,		0			},
	{ GSC_PCI_9080_ILR,			0			},
	{ GSC_PCI_9080_IPR,			0			},
	{ GSC_PCI_9080_MGR,			0			},
	{ GSC_PCI_9080_MLR,			0			},

	{ GSC_PLX_9080_LAS0RR,		0			},
	{ GSC_PLX_9080_LAS0BA,		0			},
	{ GSC_PLX_9080_MARBR,		0			},
	{ GSC_PLX_9080_BIGEND,		0			},
	{ GSC_PLX_9080_EROMRR,		0			},
	{ GSC_PLX_9080_EROMBA,		0			},
	{ GSC_PLX_9080_LBRD0,		0			},
	{ GSC_PLX_9080_DMRR,		0			},
	{ GSC_PLX_9080_DMLBAM,		0			},
	{ GSC_PLX_9080_DMLBAI,		0			},
	{ GSC_PLX_9080_DMPBAM,		0			},
	{ GSC_PLX_9080_DMCFGA,		0			},
	{ GSC_PLX_9080_LAS1RR,		0			},
	{ GSC_PLX_9080_LAS1BA,		0			},
	{ GSC_PLX_9080_LBRD1,		0			},

	{ GSC_PLX_9080_MBOX0,		0			},
	{ GSC_PLX_9080_MBOX1,		0			},
	{ GSC_PLX_9080_MBOX2,		0			},
	{ GSC_PLX_9080_MBOX3,		0			},
	{ GSC_PLX_9080_MBOX4,		0			},
	{ GSC_PLX_9080_MBOX5,		0			},
	{ GSC_PLX_9080_MBOX6,		0			},
	{ GSC_PLX_9080_MBOX7,		0			},
	{ GSC_PLX_9080_P2LDBELL,	0			},
	{ GSC_PLX_9080_L2PDBELL,	0			},
	{ GSC_PLX_9080_INTCSR,		0			},
	{ GSC_PLX_9080_CNTRL,		0			},
	{ GSC_PLX_9080_PCIHIDR,		0			},
	{ GSC_PLX_9080_PCIHREV,		0			},

	{ GSC_PLX_9080_DMAMODE0,	0			},
	{ GSC_PLX_9080_DMAPADR0,	0			},
	{ GSC_PLX_9080_DMALADR0,	0			},
	{ GSC_PLX_9080_DMASIZ0,		0			},
	{ GSC_PLX_9080_DMADPR0,		0			},
	{ GSC_PLX_9080_DMAMODE1,	0			},
	{ GSC_PLX_9080_DMAPADR1,	0			},
	{ GSC_PLX_9080_DMALADR1,	0			},
	{ GSC_PLX_9080_DMASIZ1,		0			},
	{ GSC_PLX_9080_DMADPR1,		0			},
	{ GSC_PLX_9080_DMACSR0,		0			},
	{ GSC_PLX_9080_DMACSR1,		0			},
	{ GSC_PLX_9080_DMAARB,		0			},
	{ GSC_PLX_9080_DMATHR,		0			},

	{ GSC_PLX_9080_OPLFIS,		0			},
	{ GSC_PLX_9080_OPLFIM,		0			},
	{ GSC_PLX_9080_IQP,			0			},
	{ GSC_PLX_9080_OQP,			0			},
	{ GSC_PLX_9080_MQCR,		0			},
	{ GSC_PLX_9080_QBAR,		0			},
	{ GSC_PLX_9080_IFHPR,		0			},
	{ GSC_PLX_9080_IFTPR,		0			},
	{ GSC_PLX_9080_IPHPR,		0			},
	{ GSC_PLX_9080_IPTPR,		0			},
	{ GSC_PLX_9080_OFHPR,		0			},
	{ GSC_PLX_9080_OFTPR,		0			},
	{ GSC_PLX_9080_OPHPR,		0			},
	{ GSC_PLX_9080_OPTPR,		0			},
	{ GSC_PLX_9080_QSR,			0			},

	{ DMI32_FRR,				1			},
	{ DMI32_BCR,				1			},
	{ DMI32_BSR,				1			},
	{ DMI32_TBBAR,				1			},
	{ DMI32_TBSR,				1			},
	{ DMI32_ICR,				1			},
	{ DMI32_ISR,				1			},
	{ DMI32_TSWR,				1			},
	{ DMI32_LMBR,				1			},
	{ DMI32_FR,					1			}

};



/*****************************************************************************
*
*	Function:	reg_read_test
*
*	Purpose:
*
*		Verify that all readable registers can be read.
*
*	Arguments:
*
*		handle	The handle of the board to access.
*
*	Returned:
*
*		0		All went well.
*		> 0		The number of errors encountered.
*
*****************************************************************************/

int reg_read_test(void* handle)
{
	int	errs;
	int	i;
	int	status	= GSC_SUCCESS;
	U32	u32;

	label_text("Register Read Test");

	for (i = 0; (status == GSC_SUCCESS) && (i < ARRAY_ELEMENTS(_reg_list)); i++)
		status	= dmi32_reg_read(handle, _reg_list[i].reg, &u32);

	errs	= (status == GSC_SUCCESS) ? 0 : 1;

	if (errs)
		printf("FAIL <--- (%d)\n", i);
	else
		printf("PASS (%d)\n", i);

	return(errs);
}



/*****************************************************************************
*
*	Function:	reg_write_test
*
*	Purpose:
*
*		Verify that all writeable registers can be written.
*
*	Arguments:
*
*		handle	The handle of the board to access.
*
*	Returned:
*
*		0		All went well.
*		-1		There was a problem, see errno.
*
*****************************************************************************/

int reg_write_test(void* handle)
{
	int	errs;
	int	i;
	int	ro		= 0;
	int	rw		= 0;
	int	status	= GSC_SUCCESS;
	U32	u32;

	label_text("Register Write Test");

	for (i = 0; i < ARRAY_ELEMENTS(_reg_list); i++)
	{
		status	= dmi32_reg_read(handle, _reg_list[i].reg, &u32);

		if (status != GSC_SUCCESS)
			break;

		status	= dmi32_reg_write(handle, _reg_list[i].reg, u32);

		if (_reg_list[i].writeable)
			rw++;
		else
			ro++;

		if (((_reg_list[i].writeable) && (status != GSC_SUCCESS)) ||
			((!_reg_list[i].writeable) && (status == GSC_SUCCESS)))
		{
			/* If its RW then there should be no error. */
			/* It its RO then there should be an error. */
			status	= GSC_FAILED;
			break;
		}
		else
		{
			status	= GSC_SUCCESS;
		}
	}

	errs	= (status == GSC_SUCCESS) ? 0 : 1;

	if (errs)
		printf("FAIL <--- (%d: ro %d, rw %d)\n", i, ro, rw);
	else
		printf("PASS (%d: ro %d, rw %d)\n", i, ro, rw);

	return(errs);
}


