/* Application - DMI32 - Linux */
/* $Revision: 1 $ */
/* $Date: 4/05/07 3:55p $ */

#include <stdio.h>
#include <string.h>
#include <sys/utsname.h>

#include "util_host.h"

#include "util_label.h"



/*****************************************************************************
*
*	Function:	id_host
*
*	Purpose:
*
*		Identify the operating system.
*
*	Arguments:
*
*		None.
*
*	Returned:
*
*		>= 0	The number of errors seen.
*
*****************************************************************************/

int id_host(void)
{
	char			buf[1024];
	int				end;
	FILE*			file;
	int				i;
	int				index;
	char*			psz;
	char			tmp[1024];
	struct utsname	uts;

	memset(&uts, 0, sizeof(uts));
	uname(&uts);
	label_text("Host");
	printf("\n");
	label_level_inc();

	label_text("Operating System");
	printf("%s\n", uts.sysname);
	label_text("Kernel");
	printf("%s\n", uts.release);
	label_text("Processor");
	printf("%s\n", uts.machine);
	label_level_inc();

	file	= fopen("/proc/cpuinfo", "r");

	if (file)
	{
		for (;;)
		{
			end	= feof(file);

			if (end)
				break;

			fgets(buf, sizeof(buf), file);
			i	= sscanf(buf, "processor : %d", &index);

			if (i == 1)
			{
				label_level_dec();
				sprintf(buf, "Processor #%d", index);
				label_text(buf);
				printf("\n");
				label_level_inc();
				continue;
			}

			i	= sscanf(buf, "model name : %s", tmp);

			if (i == 1)
			{
				label_text("CPU Model");
				psz	= strchr(buf, ':') + 2;
				printf("%s", psz);
				continue;
			}

			i	= sscanf(buf, "cpu MHz : %s", tmp);

			if (i == 1)
			{
				label_text("CPU Speed");
				printf("%s MHz\n", tmp);
				continue;
			}
		}

		fclose(file);
	}

	label_level_dec();
	label_level_dec();
	return(0);
}


