/* Application - DMI32 - Linux */
/* $Workfile: util_time.c $ */
/* $Revision: 1 $ */
/* $Date: 4/05/07 3:55p $ */
/* $Log: /NEW SOURCESAFE DATABASE/SDK/PLX/gsc/dmi32/utils/linux/util_time.c $
 *
 * 1     4/05/07 3:55p Dnewbold
*/

#include "util_time.h"

#include <unistd.h>
#include <sys/time.h>



/*****************************************************************************
*
*	Function:	time_delta_ms
*
*	Purpose:
*
*		Return a relative change in time in milliseconds. The change in time
*		must be relative to a fixed point in time.
*
*	Arguments:
*
*		None.
*
*	Returned:
*
*		The change in time in milliseconds.
*
*****************************************************************************/

U32 time_delta_ms(void)
{
	static	int				started	= 0;
	static	struct timeval	start;

	U32						delta;
	U32						sec;
	struct timeval			tv;
	U32						us;

	if (started == 0)
	{
		gettimeofday(&start, NULL);
		started	= 1;
	}

	gettimeofday(&tv, NULL);
	sec		= tv.tv_sec - start.tv_sec;
	us		= 1000000L + tv.tv_usec - start.tv_usec;
	delta	= (sec * 1000) + (us / 1000);
	return(delta);
}


