/* Application - DMI32 - Any OS */
/* $Workfile: util_close.c $ */
/* $Revision: 1 $ */
/* $Date: 8/22/05 4:02p $ */
/* $Log: /NEW SOURCESAFE DATABASE/SDK/PLX/gsc/dmi32/utils/util_close.c $
 *
 * 1     8/22/05 4:02p Dnewbold
*/

#include <stdio.h>

#include "dmi32_api.h"
#include "util_close.h"
#include "util_label.h"



/*****************************************************************************
*
*	Function:	dev_close
*
*	Purpose:
*
*		Implement a wrapper around the similarly named DMI32 function.
*
*	Arguments:
*
*		index	The index of the device being closed.
*
*		dev		The device handle to close.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
*****************************************************************************/

int dev_close(int index, void* dev)
{
	char	buf[64];
	int		errs	= 0;
	U32		status;

	sprintf(buf, "Closing DMI32 #%d", index);
	label_text(buf);
	status	= dmi32_close(dev);
	errs	= label_fail_func(1, "dmi32_close", status);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


