/* Application - DMI32 - Any OS */
/* $Workfile: util_count.c $ */
/* $Revision: 1 $ */
/* $Date: 8/22/05 4:02p $ */
/* $Log: /NEW SOURCESAFE DATABASE/SDK/PLX/gsc/dmi32/utils/util_count.c $
 *
 * 1     8/22/05 4:02p Dnewbold
*/

#include <stdio.h>

#include "util_count.h"
#include "util_label.h"



/*****************************************************************************
*
*	Function:	dev_board_count
*
*	Purpose:
*
*		Count the number of installed DMI32 boards.
*
*	Arguments:
*
*		None.
*
*	Returned:
*
*		>= 0	The number of boards found.
*		< 0		The number of errors encounterred here.
*
*****************************************************************************/

int dev_board_count(void)
{
	U8	count;
	int	errs;
	int	ret;
	U32	status;

	label_text("DMI32 Board Count");
	status	= dmi32_board_count(&count);
	errs	= label_fail_func(1, "dmi32_board_count", status);

	if (errs)
	{
		ret	= -1;
	}
	else if (count == 0)
	{
		ret	= 0;
		printf("No boards found\n");
	}
	else
	{
		ret	= (int) count;
		printf("%d\n", ret);
	}

	return(ret);
}


