/* Application - DMI32 - Any OS */
/* $Workfile: util_open.c $ */
/* $Revision: 1 $ */
/* $Date: 8/22/05 4:01p $ */
/* $Log: /NEW SOURCESAFE DATABASE/SDK/PLX/gsc/dmi32/utils/util_open.c $
 *
 * 1     8/22/05 4:01p Dnewbold
*/

#include <stdio.h>

#include "dmi32_api.h"
#include "util_open.h"
#include "util_label.h"



/*****************************************************************************
*
*	Function:	dev_open
*
*	Purpose:
*
*		Implement a wrapper around the similarly named DMI32 function.
*
*	Arguments:
*
*		index	The index of the board to open.
*
*		dev		The device handle is recorded here.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
*****************************************************************************/

int dev_open(U8 index, void** dev)
{
	char	buf[64];
	int		errs	= 0;
	U32		status;

	sprintf(buf, "Opening DMI32 #%d", (int) index);
	label_text(buf);
	status	= dmi32_open(index, dev);
	errs	= label_fail_func(1, "dmi32_open", status);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


