/* Application - DMI32 - Any OS */
/* $Workfile: util_status.c $ */
/* $Revision: 1 $ */
/* $Date: 8/22/05 4:02p $ */
/* $Log: /NEW SOURCESAFE DATABASE/SDK/PLX/gsc/dmi32/utils/util_status.c $
 *
 * 1     8/22/05 4:02p Dnewbold
*/

#include <stdio.h>

#include "util_status.h"

#include "dmi32_api.h"
#include "util_label.h"



/*****************************************************************************
*
*	Function:	dev_api_status
*
*	Purpose:
*
*		Make sure the API is OK to use.
*
*	Arguments:
*
*		None.
*
*	Returned:
*
*		>= 0	The number of errors encountered.
*
*****************************************************************************/

int dev_api_status(void)
{
	U32		arg;
	char	buf[256];
	int		errs;
	U32		stat;
	U32		status;
	char	sts[256];

	label_text("DMI32 API Library status");
	stat	= dmi32_api_status(&status, &arg, DMI32_API_VERSION);
	errs	= label_fail_func(1, "dmi32_api_status", stat);

	if (errs)
	{
	}
	else if (status != GSC_SUCCESS)
	{
		dmi32_status_text(status, buf, sizeof(buf));
		sprintf(sts, "%s, arg 0x%lX", buf, (long) arg);
		errs	= label_fail_text(1, sts);
	}
	else
	{
		errs	= 0;
		printf("PASS\n");
	}

	return(errs);
}


